
#ifndef _WRAPPER_H_
#define _WRAPPER_H_
#endif
#undef  __io_virt_debug
#define __io_virt_debug(a, f, l) (a)

#define OSS_GFP_KERNEL		0x01
#define OSS_GFP_DMA		0x02

#define WRAPPER_VERSION  1
typedef struct {int dont_try_to_use_this_field;}wait_handle;
typedef struct {int dont_try_to_use_this_field;}poll_table_handle, select_table_handle;
typedef struct {int dont_try_to_use_this_field;}pci_handle;
typedef struct {int dont_try_to_use_this_field;}file_handle;
typedef struct {int dont_try_to_use_this_field;}vm_area_handle;
typedef struct {int dont_try_to_use_this_field;}page_handle;
typedef struct {int dont_try_to_use_this_field;}inode_handle;
typedef struct {int dont_try_to_use_this_field;}dentry_handle;
typedef struct {int dont_try_to_use_this_field;}ac97_codec_handle;
typedef struct {int dont_try_to_use_this_field;}module_handle;
typedef struct {int dont_try_to_use_this_field;}dma_addr_handle;
typedef struct {int dont_try_to_use_this_field;}semaphore_handle;
typedef struct {int dont_try_to_use_this_field;}phandle;
typedef struct {int dont_try_to_use_this_field;}task_handle;
typedef struct {int dont_try_to_use_this_field;}pci_dev_handle;

struct pci_driver_handle  {
	char * name;
	const struct pci_device_id *id_table;
	int (*probe) (pci_dev_handle *,const struct pci_device_id *);
	void (*remove) (pci_dev_handle *);

};

struct ac97_operation_handle {
	u16 (*ac97_read_t) (ac97_codec_handle *,u8);
	void (*ac97_write_t) (ac97_codec_handle *,u16,u8);
};

struct file_operation_handle {
#if LINUX_VERSION_CODE >= 132096 /*2.4.x*/
 	module_handle *owner;
#endif
#if LINUX_VERSION_CODE > 131328 /* 2.1.x */
	long long (*lseek) (file_handle *, long long, int);
#else
	int (*lseek) (inode_handle *, file_handle *, off_t, int);
#endif
#if LINUX_VERSION_CODE > 131328 /* 2.1.x */
	ssize_t (*read) (file_handle *, char *, size_t, loff_t *);
#else
	int (*read) (inode_handle *, file_handle *, char *, int);
#endif
#if LINUX_VERSION_CODE > 131328 /* 2.1.x */
	ssize_t (*write) (file_handle *, const char *, size_t, loff_t *);
#else
	int (*write) (inode_handle *, file_handle *, const char *, int);
#endif
	int (*readdir) (inode_handle *, file_handle *, void *, filldir_t);
#if LINUX_VERSION_CODE > 131328 /* 2.1.x */
	unsigned int (*poll) (file_handle *, poll_table_handle *);
#else
	int (*select) (inode_handle *, file_handle *, int, select_table_handle *);
#endif
	int (*ioctl) (inode_handle *, file_handle *, unsigned int, unsigned long);
#if LINUX_VERSION_CODE > 131328 /* 2.1.x */
	int (*mmap) (file_handle *, vm_area_handle *);
#else
	int (*mmap) (inode_handle *, file_handle *, vm_area_handle *);
#endif
	int (*open) (inode_handle *, file_handle *);
#if LINUX_VERSION_CODE > 131328 /* 2.1.x */
	int (*release) (inode_handle *, file_handle *);
#else
	void (*release) (inode_handle *, file_handle *);
#endif
	int (*fsync) (inode_handle *, file_handle *);
	int (*fasync) (inode_handle *, file_handle *, int);
#if LINUX_VERSION_CODE<131858 /* Prior 2.3.x */
	int (*check_media_change) (kdev_t dev);
	int (*revalidate) (kdev_t dev);
#endif
}file_operation_handle;


